--RandomMount V0.9.3
--Author: Mike Hendricks(AttilaTheFun)
--Description:
--              This add-on makes it simple to summon a random mount it takes into account ridding level, cold weather flying,
--              flying areas, even race and summons an appropriate mount.
--              It has a simple interface /mnt: will summon riding/flying mounts in the appropriate areas
--                                        /mnt: will summon riding/flying mounts in the appropriate areas.
--                                        /rmount: Same as /mnt
--                                        /mnt riding: summons riding mounts in flying areas
--                                        /mnt flying: force an attempt to summon a flying mount
--                                        /mnt %t (search Term): summons a mount based on specified search term.
--                                                example: to summon a skeletal warhorse type: /mnt skeletal
--                                        /mnt epicfly: toggle summoning of epic flying mounts
--                                        /mnt epicride: toggle summoning of epic riding mounts
--                                        /mnt undercity: toggle filter to summon only skeletal warhorses or wolfs in Undercity
--                                        /mnt filter: toggle mount filtering
--                                        /mnt add %t: Remove all mounts matching %t if filter is enabled
--                                        /mnt config: Prints the current configuration
--                                        /mnt filters: Lists current filters
--                                        /mnt clear: removes all filters
--                                        /mnt debug: toggle debug printing for posting error messages
--                                        /mnt No Flag: Summon a appropriate mount for the area

--If you are in undercity most mounts are to large to get easily throug out of the elivators, so if you have wolf,
-- or skeletal warhorses it will summon only those inside of undercity.

-- mount dictionary to compensate for wow's terrible GetCompanionInfo("MOUNT", i) command.
--One would assume info would imply useful things like can it fly and what skill is required etc.
-- mount codes --
-- add the numbers together for special mounts. ie both epic riding and epic flying = 20
--1  = slow Mount(Not Summoned)
--2  = riding mount
--4  = epic riding mount
--8  = flying mount
--16 = epic flying mount
--32 = special mount(for area specific mounts)
local mountDict = {["Winged Steed of the Ebon Blade"] = 24,
["Swift Red Wind Rider"] = 16,
["Swift Green Wind Rider"] = 16,
["Swift Yellow Wind Rider"] = 16,
["Swift Purple Wind Rider"] = 16,
["Swift Blue Gryphon"] = 16,
["Swift Green Gryphon"] = 16,
["Swift Purple Gryphon"] = 16,
["Swift Red Gryphon"] = 16,
["Blue Riding Nether Ray"] = 16,
["Purple Riding Nether Ray"] = 16,
["Green Riding Nether Ray"] = 16,
["Red Riding Nether Ray"] = 16,
["Silver Riding Nether Ray"] = 16,
["Violet Netherwing Drake"] = 16,
["Veridian Netherwing Drake"] = 16,
["Azure Netherwing Drake"] = 16,
["Onyx Netherwing Drake"] = 16,
["Purple Netherwing Drake"] = 16,
["Cobalt Netherwing Drake"] = 16,
["Azure Drake"] = 16,
["Blue Drake"] = 16,
["Albino Drake"] = 16,
["Bronze Drake Mount"] = 16,
["Red Drake"] = 16,
["Twilight Drake"] = 16,
["Black Drake"] = 16,
["Cenarion War Hippogryph"] = 16,
["Armored Snowy Gryphon"] = 16,
["Armored Blue Wind Rider"] = 16,
["Flying Carpet"] = 8,
["Flying Machine"] = 8,
["Turbo-Charged Flying Machine"] = 16,
["Albino Drake"] = 16,
["Red Proto-Drake"] = 16,
["Blue Proto-Drake"] = 16,
["Green Proto-Drake"] = 16,
["Plagued Proto-Drake"] = 16,
["Black Proto-Drake"] = 16,
["Time-Lost Proto-Drake"] = 16,
["Swift Nether Drake"] = 16,
["X-51 Nether-Rocket"] = 16,
["X-51 Nether-Rocket X-TREME"] = 16,
["Tawny Wind Rider"] = 8,
["Blue Wind Rider"] = 8,
["Green Wind Rider"] = 8,
["Ebon Gryphon"] = 8,
["Golden Gryphon"] = 8, 
["Snowy Gryphon"] = 8,
["Swift Green Hawkstrider"] = 4,
["Swift Pink Hawkstrider"] = 4,
["Swift Purple Hawkstrider"] = 4,
["Great Blue Elekk"] = 4,
["Great Green Elekk"] = 4, 
["Great Purple Elekk"] = 4,
["Swift Brown Wolf"] = 36,
["Swift Timber Wolf"] = 36,
["Swift Gray Wolf"] = 36,
["Purple Skeletal Warhorse"] = 36,
["Green Skeletal Warhorse"] = 36,
["Swift Blue Raptor"] = 36,
["Swift Olive Raptor"] = 36,
["Swift Orange Raptor"] = 36,
["Swift Gray Ram"] = 4,
["Swift Brown Ram"] = 4,
["Swift White Ram"] = 4,
["Swift Mistsaber"] = 4, 
["Swift Stormsaber"] = 4,
["Swift Frostsaber"] = 4,
["Swift Green Mechanostrider"] = 4,
["Swift Yellow Mechanostrider"] = 4,
["Swift White Mechanostrider"] = 4,
["Great Gray Kodo"] = 4,
["Great White Kodo"] = 4,
["Great Brown Kodo"] = 4,
["Swift Palomino"] = 4,
["Swift White Steed"] = 4,
["Swift Brown Steed"] = 4,
["Charger"] = 4,
["Thalassian Warhorse"] = 4,
["Thalassian Charger"] = 4,
["Summon Charger"] = 4,
["Warhorse"] = 2,
["Summon Warhorse"] = 2,
["Dreadsteed"] = 4,
["Acherus Deathcharger"] = 4,
["Red Skeletal Warhorse"] = 36,
["Black War Steed"] = 4,
["Black War Wolf"] = 36,
["Black War Tiger"] = 4, 
["Black War Kodo"] = 4,
["Black War Ram"] = 4,
["Black War Raptor"] = 36,
["Black Battlestrider"] = 4,
["Swift Warstrider"] = 4,
["Black War Elekk"] = 4,
["Dark War Talbuk"] = 4,
["Dark Riding Talbuk"] = 4,
["Stormpike Battle Charger"] = 4,
["Frostwolf Howler"] = 36,
["Big Blizzard Bear"] = 4,
["Black War Bear"] = 4,
["Armored Brown Bear"] = 4, 
["White Polar Bear"] = 4,
["White Polar Bear Mount"] = 4,
["Big Battle Bear"] = 4,
["Wooly Mammoth"] = 4,
["Traveler's Tundra Mammoth"] = 4,
["Mekgineer's Chopper"] = 4,
["Mechano-hog"] = 4,
["Swift White Hawkstrider"] = 4,
["Amani War Bear"] = 4,
["Fiery Warhorse"] = 4,
["Swift Spectral Tiger"] = 6,
["Swift Zhevra"] = 4,
["Raven Lord"] = 4, 
["Rivendare's Deathcharger"] = 36,
["Winterspring Frostsaber"] = 4,
["Swift Razzashi Raptor"] = 4,
["Swift Zulian Tiger"] = 4,
["Black Qiraji Battle Tank"] = 4,
["Great Brewfest Kodo"] = 4,
["Brewfest Ram"] = 4,
["Cobalt Riding Talbuk"] = 4,
["Silver Riding Talbuk"] = 4,
["Tan Riding Talbuk"] = 4,
["White Riding Talbuk"] = 4,
["Cobalt War Talbuk"] = 4,
["Silver War Talbuk"] = 4,
["Tan War Talbuk"] = 4,
["White War Talbuk"] = 4,
["Black Hawkstrider"] = 2,
["Blue Hawkstrider"] = 2,
["Purple Hawkstrider"] = 2,
["Red Hawkstrider"] = 2,
["Brown Elekk"] = 2,
["Gray Elekk"] = 2,
["Purple Elekk"] = 2,
["Dire Wolf"] = 34,
["Timber Wolf"] = 34,
["Brown Wolf"] = 34,
["Red Skeletal Horse"] = 34,
["Blue Skeletal Horse"] = 34,
["Brown Skeletal Horse"] = 34,
["Violet Raptor"] = 34,
["Emerald Raptor"] = 34,
["Turquoise Raptor"] = 34,
["White Ram"] = 2,
["Brown Ram"] = 2,
["Gray Ram"] = 2,
["Spotted Frostsaber"] = 2,
["Striped Frostsaber"] = 2,
["Striped Nightsaber"] = 2,
["Unpainted Mechanostrider"] = 2,
["Red Mechanostrider"] = 2,
["Blue Mechanostrider"] = 2,
["Green Mechanostrider"] = 2,
["Brown Kodo"] = 2,
["Gray Kodo"] = 2,
["Pinto"] = 2,
["Brown Horse"] = 2,
["Black Stallion"] = 2,
["Chestnut Mare"] = 2,
["Felsteed"] = 2,
["Blue Qiraji Battle Tank"] = 32,
["Green Qiraji Battle Tank"] = 32,
["Red Qiraji Battle Tank"] = 32,
["Yellow Qiraji Battle Tank"] = 32,
["Headless Horseman's Mount"] = 20,
["Headless Horseman Mount"]=20,
["Frost Ram"] = 4,
["Green Kodo"] = 4,
["White Mechanostrider Mod B"] = 4,
["Merciless Nether Drake"] = 16,
["White Stallion"] = 4,
["Black War Mammoth"] = 4,
["Winter Wolf"] = 4,
["Grand Ice Mammoth"] = 4,
["Brutal Nether Drake"] = 16,
["Ashes of Al'ar"] = 16,
["Red Wolf"] = 4,
["Ivory Raptor"] = 4,
["Swift Brewfest Ram"] = 4,
["Black Nightsaber"] = s4,
["Mottled Red Raptor"] = 4,
["Black Ram"] = 4,
["Teal Kodo"] = 4,
["Icy Blue Mechanostrider Mod A"] = 4,
["Vengeful Nether Drake"] = 16,
["Palomino"] = 4,
["Magnificent Flying Carpet"] = 16,
["Ancient Frostsaber"] = 4,
["Icy Blue Mechanostrider Mod A"] = 4,
["Ice Mammoth"] = 4,
["Black Skeletal Horse"] = 2,
["Black Wolf"] = 2,
["White Kodo"] = 2,
["Ironbound Proto-Drake"] = 16,
["Rusted Proto-Drake"] = 16,
["Sea Turtle"] = 2,
["Forsaken Warhorse"] = 4,
["White Skeletal Warhose"]=4,
["Swift Forsaken Warhorse"] = 4,
["Swift Orgrimmar Wolf"] = 4,
["Orgrimmar Wolf"]=4,
["Swift Burgundy Wolf"]=4,
["Great Mulgore Kodo"] = 4,
["Great Golden Kodo"]=4,
["Swift Darkspear Raptor"] = 4,
["Darkspear Raptor"] = 4,
["Swift Silvermoon Hawkstrider"] = 4,
["Silvermoon Hawkstrider"] = 4,
["Swift Elwynn Steed"] = 4,
["Swift Purple Raptor"] = 4,
["Swift Darnassian Mistsaber"] = 4,
["Darnassian Nightsaber"]=4,
["Swift Ironforge Ram"] = 4,
["Exodar Elekk"]=4,
["Ironforge Ram"]=4,
["Great Azuremyst Elekk"] = 4,
["Gnomeregan Mechanostrider"]=4,
["Turbostrider"] = 4,
["Argent Hippogryph"] = 16,
["Swift Red Hawkstrider"] = 4,
["Deadly Gladiator's Frostwyrm"] = 16,
["Great Red Elekk"] = 4,
["Swift Gray Steed"] = 4,
["Magic Rooster"] = 4,
["Swift Moonsaber"] = 4,
["Swift Violet Ram"] = 4,
["Turbostrider"] = 4,
["Stormwind Steed"]=4,
["Riding Turtle"] = 1}

--Saved Variables
debug = false
notWanted = {}
removeMount = false
epicfly = true
epicride = true
ucFilter = true

--names to check for cold weather flying
local zoneIndex = {"Howling Fjord", "Borean Tundra", "Dragonblight", "Grizzly Hills", "Zul'Drak", "Sholazar Basin",
            "The Storm Peaks", "Crystalsong Forest", "Icecrown", "Windergrasp", "Coldarra", "The Frozen Sea"}

function RandomMount_OnLoad()
 SlashCmdList["ADDONNAME"] = FindMount;
 SLASH_ADDONNAME1 = "/mnt";
 SLASH_ADDONNAME2 = "/rmount";
end

function CanFlyHere( )
	-- Check for flyable area
	if not IsFlyableArea( ) then return( false ) end

	local coldWeather = IsUsableSpell( "Cold Weather Flying" )

	-- Check for Dalaran
	if GetRealZoneText( ) == "Dalaran" then
		if (GetMinimapZoneText( ) == "Krasus' Landing" or GetMinimapZoneText() == "The Underbelly") and coldWeather then
            return( true )
        end
		return( false )
	end
	-- Check for Wintergrasp
	if GetRealZoneText( ) == "Wintergrasp" then
        return( false )
    end
	-- Northrend check
	local zoneText = GetRealZoneText()
	for i, zone in ipairs( zoneIndex ) do
        if zoneText == zone then
			if coldWeather then return( true ) end
			return( false )
		end
	end

	return( true )
end

function GetRidingSkill()
    --get the current riding skill
    for skillIndex = 1, GetNumSkillLines() do
        skillName, isHeader, _, skillRank = GetSkillLineInfo(skillIndex)
        if isHeader == nil then
            if skillName == "Riding" then
                return( skillRank )
            end
        end
    end
    return ( 0 )
end

function HasZoneMounts(flying, wolf, qiraji, searchMount, search)
    --check to see if special zone mounts are learned and process search
    for i=1,GetNumCompanions("MOUNT"),1 do
        local _, creatureName = GetCompanionInfo("MOUNT", i)
        if search ~= '' then
            if string.find(string.lower(creatureName), string.lower(search)) then
                table.insert(searchMount, i)
            end
        end
        local chk = true
        if creatureName:find("Wolf") then
            chk = true
            for n, notW in ipairs( notWanted ) do
                if string.find(string.lower(creatureName), string.lower(notW)) then
                    chk = false
                    break
                end
            end
            if chk then
                table.insert(wolf, i)
            end
        elseif creatureName:find("Skeletal") then
            chk = true
            for n, notW in ipairs( notWanted ) do
                if string.find(string.lower(creatureName), string.lower(notW)) then
                    chk = false
                    break
                end
            end
            if chk then
                table.insert(wolf, i)
            end
        elseif creatureName:find("Rivendare") then
            chk = true
            for n, notW in ipairs( notWanted ) do
                if string.find(string.lower(creatureName), string.lower(notW)) then
                    chk = false
                    break
                end
            end
            if chk then
                table.insert(wolf, i)
            end
        elseif creatureName:find("Qiraji") then
            chk = true
            for n, notW in ipairs( notWanted ) do
                if string.find(string.lower(creatureName), string.lower(notW)) then
                    chk = false
                    break
                end
            end
            if chk then
                table.insert(qiraji, i)
            end
        else
            if mountDict[creatureName] then
                if ((mountDict[creatureName] / 8) % 2) >= 1 or ((mountDict[creatureName] / 16) % 2) >= 1 then
                    table.insert(flying, i)
                end
            else
                PrintHelp(creatureName .. " not in table, please report on curse.com. version 0.9.3", "FF00ff00")
            end
        end
    end
    --PrintHelp(table.concat(wolf, ", "), "FFff0000")
    return flying, wolf, qiraji, searchMount
end

function FindMount(arg1)
	local s = 0
	local r
    local wolf = {}
    local qiraji = {}
    local flying = {}
    local search = ""
    local searchMount = {}
	local zoneText = GetRealZoneText()
    local zoneMounts = 2
    local canFly
    local ridingSK = GetRidingSkill()

    if arg1 == "riding" then
        canFly = false
    elseif arg1 == "help" then
        PrintHelp("Random Mount v0.9.3 optional flags:\r riding: Summon only ground based mounts\r flying: Force attempt to summon a flying mount\r %t (Search Term): Summon a mount containing the term you specify('/mnt wolf' summons a wolf) \r epicfly: toggle summoning of epic flying mounts\r epicride: toggle summoning of epic riding mounts\r undercity: toggle filter to summon only skeletal warhorses or wolfs in Undercity\r filter: toggle mount filtering\r add %t: Remove all mounts matching %t if filter is enabled\r config: Prints the current configuration\r filters: Lists current filters\r clear: removes all filters\r debug: Toggle debug printing for posting error messages\r No Flag: Summon a appropriate mount for the area", "FFFFFF00")
        return
    elseif arg1 == "config" then
        if debug then
            PrintHelp("Debug: Enabled", "FF00ff00")
        else
            PrintHelp("Debug: Disabled", "FFff0000")
        end
        if removeMount then
            PrintHelp("Mounts filtered: " .. table.concat(notWanted, ", "), "FF00ff00")
        else
            PrintHelp("Mount Removal Disabled.", "FFff0000")
        end
        if epicfly then
            PrintHelp("Epic flying enabled.", "FF00ff00")
        else
            PrintHelp("Epic flying disabled.", "FFff0000")
        end
        if epicride then
            PrintHelp("Epic riding enabled.", "FF00ff00")
        else
            PrintHelp("Epic riding disabled.", "FFff0000")
        end
        if ucFilter then
            PrintHelp("Undercity mount filtering enabled.", "FF00ff00")
        else
            PrintHelp("Undercity mount filtering disabled.", "FFff0000")
        end
        return
    elseif arg1 == "debug" then
        if debug == false then
            debug = true
            PrintHelp("Debug information enabled.", "FF00ff00")
        elseif debug == true then
            debug = false
            PrintHelp("Debug information disabled.", "FFff0000")
        end
        return
    elseif arg1 == "epicfly" then
        if epicfly == false then
            epicfly = true
            PrintHelp("Epic flying enabled.", "FF00ff00")
        elseif epicfly == true then
            epicfly = false
            PrintHelp("Epic flying disabled.", "FFff0000")
        end
        return
    elseif arg1 == "undercity" then
        if ucFilter == false then
            ucFilter = true
            PrintHelp("Undercity mount filtering enabled.", "FF00ff00")
        elseif ucFilter == true then
            ucFilter = false
            PrintHelp("Undercity mount filtering disabled.", "FFff0000")
        end
        return
    elseif arg1 == "epicride" then
        if epicride == false then
            epicride = true
            PrintHelp("Epic riding enabled.", "FF00ff00")
        elseif epicride == true then
            epicride = false
            PrintHelp("Epic riding disabled.", "FFff0000")
        end
        return
    elseif arg1 == "filter" then
        if removeMount == false then
            removeMount = true
            PrintHelp("Mount removal enabled.", "FF00ff00")
        elseif removeMount == true then
            removeMount = false
            PrintHelp("Mount removal eisabled.", "FFff0000")
        end
        return
    elseif arg1 == "filters" then
        if removeMount then
            PrintHelp("Mounts filtered: " .. table.concat(notWanted, ", "), "FF00ffff")
        else
            PrintHelp("Mount Removal Disabled.", "FFff0000")
        end
        return
    elseif arg1 == "clear" then
        notWanted = {}
        PrintHelp("Remove mount table cleared.", "FF00ffff")
        return
    elseif arg1 == "flying" then
        canFly = true
    elseif arg1:find("add") then
        local found = false
        if string.len(string.sub(arg1, 5)) > 0 then
            for n, notW in ipairs( notWanted ) do
                if string.sub(arg1, 5) == notW then
                    PrintHelp(string.sub(arg1, 5) .. " already added.", "FF00ffff")
                    found = true
                    break
                end
            end
            --PrintHelp(table.concat(notWanted, ", "), "FF00ffff")
            if not found then
                PrintHelp("Mounts matching " .. string.sub(arg1, 5) .. " will no longer be summoned.", "FF00ff00")
                table.insert(notWanted, string.sub(arg1, 5))
            end
        end
        return
    elseif arg1 == "rnd" then
      	r = randomSudo(GetNumCompanions("MOUNT"))
	    PrintHelp(r, "FF00ffff")
    else
        search = arg1
        canFly = CanFlyHere()
    end
    if IsMounted()
        then Dismount() 
        return
    end
    if UnitInVehicle(UnitName("player")) then
        VehicleExit()
        return
    end
    local flying, wolf, qiraji, searchMount = HasZoneMounts(flying, wolf, qiraji, searchMount, search)
    if search ~= "" and next (searchMount) == nil then
        PrintHelp("No matching mount found.", "FF00ffff") return
    end
    local runawayChk = 0
    if ridingSK >= 75 then
    	repeat
    		r = random(GetNumCompanions("MOUNT"))
    		s = TestMount(r, ridingSK, zoneText, canFly, flying, wolf, qiraji, searchMount, debug)
    		runawayChk = runawayChk + 1
    		if runawayChk > 1000 then
                s = true
    		elseif runawayChk > 500 then
                canFly = false
    		end
    	until s == true
    	if runawayChk > 1000 then
    	   PrintHelp("No usable mounts found", "FFff0000")
    	else
            CallCompanion("MOUNT", r)
        end
    end
end

function TestMount(r, ridingSK, zoneText, canFly, flying, wolf, qiraji, searchMount, debug)
    local _, creatureName = GetCompanionInfo("MOUNT", r)
    local mv = mountDict[creatureName]
    if mv then
        if removeMount then
            for n, notW in ipairs( notWanted ) do
                if string.find(string.lower(creatureName), string.lower(notW)) then
                    return false
                end
            end
        end
        --flying mounts
        if canFly and #flying > 0 and ridingSK >= 225 then
            if ridingSK >= 300 and ((mv/ 16) % 2) >= 1 and epicfly then
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 11) end
                            return true
                        end
                    end
                else
                    if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 10) end
                    return true
                end
            elseif (ridingSK == 225 or not epicfly) and ((mv / 8) % 2) >= 1 then
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 21) end
                            return true
                        end
                    end
                else
                    if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 20) end
                    return true
                end
            end
        --zone specific mounts
        elseif zoneText == "Undercity" and #wolf > 0 and ucFilter then
            if ridingSK >= 150 and epicride and ((mv / 4) % 2) >= 1 then
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 41) end
                            return true
                        end
                    end
                elseif ((mv / 32) % 2) >= 1 and (creatureName:find("Wolf") or creatureName:find("Skeletal") or creatureName:find("Rivendare")) then
                    if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 30) end
                    return true
                end
            elseif (ridingSK == 75 or not epicride) and ((mv / 2) % 2) >= 1 then
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 41) end
                            return true
                        end
                    end
                elseif ((mv / 32) % 2) >= 1 and (creatureName:find("Wolf") or creatureName:find("Skeletal") or creatureName:find("Rivendare")) then
                    if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 40) end
                    return true
                end
            end
        elseif zoneText == "Ahn'Qiraj" and #qiraji > 0 then
            if ridingSK >= 150 and ((mv / 32) % 2) >= 1 then
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 36) end
                            return true
                        end
                    end
                elseif creatureName:find("Qiraji") then
                    if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 35) end
                    return true
                end
            end
        --Regular Mounts
        else
            if ridingSK >= 150 and ((mv / 4) % 2) >= 1 and epicride then
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 51) end
                            return true
                        end
                    end
                else
                    if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 50) end
                    return true
                end
            elseif (ridingSK == 75 or not epicride) and ((mv / 2) % 2) >= 1 then
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 61) end
                            return true
                        end
                    end
                else
                    if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 60) end
                    return true
                end
            end
        end
    end
end



function PrintHelp(cmd, color)
	print(format('|c%s%s|r', color, cmd))
end

function PrintSummon(color, creatureName, r, ridingSK, creatureDict, zoneText, canFly, mountNum)
    canFly = tostring(canFly)
	print(format("|c%s%s - Mnt#:%s - Skill: %s - type:%s - %s - %s - flyZone:%s - cond:%s|r", color, creatureName, r, ridingSK, creatureDict, zoneText, GetMinimapZoneText(), canFly, mountNum))
end

function randomSudo(max)
   local oldrandom = math.random
   local randomtable
   math.random = function ()
      if randomtable == nil then
         randomtable = {}
         for i = 1, max do
            randomtable[i] = oldrandom()
         end
      end
      local x = oldrandom()
      local i = 1 + math.floor(max*x)
      x, randomtable[i] = randomtable[i], x
      return x
   end
end